// ace.cpp:
//
// access control entry class
//
// jim frost 04.06.95

#include "security.hpp"

AccessControlEntry::AccessControlEntry(void)
{
  type = 0;
  sid = NULL;
  flags = 0;
  mask = 0;
}

AccessControlEntry::~AccessControlEntry(void)
{
  if (sid != NULL)
    delete sid;
}

unsigned int
AccessControlEntry::GetType(void)
{
  return type;
}

void
AccessControlEntry::SetType(unsigned int new_type)
{
  type = new_type;
}

unsigned int
AccessControlEntry::GetFlags(void)
{
  return flags;
}

void
AccessControlEntry::SetFlags(unsigned int new_flags)
{
  flags = new_flags;
}

void
AccessControlEntry::AddFlags(unsigned int new_flags)
{
  flags |= new_flags;
}

void
AccessControlEntry::RemoveFlags(unsigned int old_flags)
{
  flags &= ~old_flags;
}

unsigned int
AccessControlEntry::GetMask(void)
{
  return mask;
}

void
AccessControlEntry::SetMask(unsigned int new_mask)
{
  mask = new_mask;
}

void
AccessControlEntry::AddMask(unsigned int new_mask)
{
  mask |= new_mask;
}

void
AccessControlEntry::RemoveMask(unsigned int old_mask)
{
  mask &= ~old_mask;
}

SecurityIdentifier*
AccessControlEntry::GetSecurityIdentifier(void)
{
  return sid;
}

void
AccessControlEntry::SetSecurityIdentifier(SecurityIdentifier* new_sid)
{
  sid = new SecurityIdentifier(new_sid);
}

const char*
AccessControlEntry::GetAccount(void)
{
  if (sid == NULL)
    return "<unset>";
  else
    return sid->GetAccount();
}
